#pragma once

#define CONNECTING_STATE 0
#define READING_STATE 1
#define WRITING_STATE 2
#define INSTANCES 4
#define PIPE_TIMEOUT 5000
#define BUFSIZE 4096

// ܵɶ˿ͶݵI/O
typedef enum _OPERATION_TYPE
{
    OP_ACCEPT, // Accept;
    OP_SEND,   // Ͳ
    OP_RECV,   // ղ
    OP_MAX     // ;
} OPERATION_TYPE;

// IO;
typedef struct _PER_IO_CONTEXT
{
    OVERLAPPED m_Overlapped;
    HANDLE m_PipeAccept;
    OPERATION_TYPE m_OpType;
    TCHAR chRequest[BUFSIZE];
    DWORD cbRead;
    TCHAR chReply[BUFSIZE];
    DWORD cbToWrite;
    // ܵ״̬;
    DWORD dwState;
    // IOǷڵȴ;
    BOOL fPendingIO;
    // ͻ˽̴;
    TCHAR chClientName[255];
    // ͻ˽PID;
    DWORD dwProcessId;

    // ʼ
    _PER_IO_CONTEXT()
    {
        ZeroMemory(&m_Overlapped, sizeof(m_Overlapped));
        ZeroMemory(chRequest, BUFSIZE);
        ZeroMemory(chReply, BUFSIZE);
        ZeroMemory(chClientName, 255);
        m_PipeAccept = INVALID_HANDLE_VALUE;
        m_OpType = OP_ACCEPT;
        fPendingIO = FALSE;
        dwProcessId = 0;
        dwState = 0;
    }

    // ͷŵ
    ~_PER_IO_CONTEXT()
    {
        if (m_PipeAccept != INVALID_HANDLE_VALUE)
        {
            CloseHandle(m_PipeAccept);
            m_PipeAccept = INVALID_HANDLE_VALUE;
        }
    }

    // û
    void ResetBuffer()
    {
        ZeroMemory(chRequest, BUFSIZE);
        ZeroMemory(chReply, BUFSIZE);
        ZeroMemory(chClientName, 255);
    }

} PER_IO_CONTEXT, *PPER_IO_CONTEXT;

//====================================================================================
//
//				CIOCPPipeඨ
//
//====================================================================================

// ̵̲߳߳
class CIOCPPipe;
typedef struct _tagThreadParams_WORKER
{
    CIOCPPipe *pIOCPModel; // ָ룬ڵеĺ
    int nThreadNo;          // ̱߳

} THREADPARAMS_WORKER, *PTHREADPARAM_WORKER;

// CIOCPPipe
class CIOCPPipe
{
public:
    CIOCPPipe(void);
    ~CIOCPPipe(void);

public:
    // 
    bool Start();

    //	ֹͣ
    void Stop();

    // ָ룬ڵʾϢ
    void SetMainDlg(CDialog *p) { m_pMain = p; }

protected:
    // ʼIOCP
    bool _InitializeIOCP();

    // ͷԴ
    void _DeInitialize();

    // ͶAccept
    bool _PostAccept();

    // Ͷݽ
    bool _PostRecv(PER_IO_CONTEXT *pIoContext);

    // пͻʱ򣬽д
    bool _DoAccpet(PER_IO_CONTEXT *pIoContext);

    // нյݵʱ򣬽д
    bool _DoRecv(PER_IO_CONTEXT *pIoContext);

    // ͻ˵Ϣ洢
    void _AddToContextList(PER_IO_CONTEXT *pIoContext);

    // ͻ˵ϢƳ
    void _RemoveContext(PER_IO_CONTEXT *pIoContext);

    // տͻϢ
    void _ClearContextList();

    // 󶨵ɶ˿
    bool _AssociateWithIOCP(PER_IO_CONTEXT *pIoContext);

    // ɶ˿ϵĴ
    bool HandleError(PER_IO_CONTEXT *pIoContext, const DWORD &dwErr);

    // ̺߳ΪIOCPĹ߳
    static DWORD WINAPI _WorkerThread(LPVOID lpParam);

    // ñĴ
    int _GetNoOfProcessors();

    // жϿͻSocketǷѾϿ
    bool _IsSocketAlive(SOCKET s);

    // ʾϢ
    void _ShowMessage(const CString szFormat, ...) const;

private:
    HANDLE m_hShutdownEvent; // ֪ͨ߳ϵͳ˳¼Ϊܹõ˳߳

    HANDLE m_hIOCompletionPort; // ɶ˿ڵľ

    HANDLE *m_phWorkerThreads; // ̵߳ľָ

    int m_nThreads; // ɵ߳

    CString m_strIP; // ˵IPַ
    int m_nPort;     // ˵ļ˿

    CDialog *m_pMain; // Ľָ룬ʾϢ

    CRITICAL_SECTION m_csContextList; // Worker߳ͬĻ

    CArray<PER_IO_CONTEXT *> m_arrayClientContext; // ͻSocketContextϢ

};
