#pragma once

namespace GameAssist {

	// ģͼƬ;
	typedef struct __META_IMG__ 
	{
		std::string name;		// ;
		std::string file_path;	// ·;
		std::string desc;		// ;
		int x = -1;
		int y = -1;
		int width = 0;
		int height = 0;
		cv::Mat img;

		void LoadImage()
		{
			if (PathFileExists(file_path.c_str()))
			{
				img = cv::imread(file_path.c_str(), cv::IMREAD_COLOR);
			}
		}
	}METAGRAPH, *LPMETAGRAPH;

	typedef struct __GACTION__ {
		byte			byActionType;			// ;
		std::string		strActionName;			// ;
		POINT			ptClick;
		POINT			ptStart;
		POINT			ptEnd;
	}GAction, * pGAction;

	typedef struct POINT_NPC
	{
		POINT ptMap;	// npcڵͼ;
		POINT ptNpc;	// npc;
	}PNPC, * pPNPC;

	extern std::map<std::string, POINT> g_mapZYNPC;
	extern std::map<std::string, PNPC> g_mapZYNPC2;
	extern std::map<std::string, METAGRAPH> g_mapMetaGraph;

	extern void LoadMetaGraph();
	// POINT
	// һPOINT
	// ˫POINT
	// ƶPOINTPOINT
	// ϶POINTPOINT
	// а壺ַ
	// CTRL/ALT/SHIFT + KeyճCTRL+CѰ·NPCҡƷ
	// ͼ
	// ս״̬
	// ״̬
	// Ʒ
	// NPC
	// ұأ
	// Ϲţ
	// Դѣ
	// Ʒ

	class CAction
	{
		HWND m_hGameWnd;
		static ThreadSection m_ts;
		POINT m_ptCur;
public:
		// ƶ;
		void MouseMove(POINT pt, bool bSetCurPos = true);
		void MouseMove(POINT ptStart, POINT ptEnd, bool bSetCurPos = true);
		void MouseMoveEx(POINT pt, bool bSetCurPos = true);
		void MouseMoveEx(POINT ptStart, POINT ptEnd, bool bSetCurPos = true);
		// 굥;
		void MouseClick();
		void MouseClick(POINT pt);
		// ˫;
		void MouseDbClick();
		void MouseDbClick(POINT pt);
		// һ;
		void MouseRClick();
		void MouseRClick(POINT pt);
		// ϶;
		void MouseDrag(POINT pt);

		// Ͱ;
		void SendKey(DWORD key, BOOL bCtrl = FALSE, BOOL bAtl = FALSE, BOOL bShift = FALSE);
		void SendKeyFast(DWORD key, BOOL bCtrl = FALSE, BOOL bAtl = FALSE, BOOL bShift = FALSE);
	public:
		CAction(HWND hWnd);
		~CAction();

		// ʼNPC;
		static void InitNPCInfo();
		// ǰ;
		void SetGameForeground();
		// Ƿֹͣ·;
		bool IsWalkStop();
		// Ƿս;
		bool IsFighting();
		// Ϸвƥͼ;
		CRect FindMatchIcon(LPCTSTR lpszTemplateImage);
		// Ƿָĵͼ;
		bool IsOnMap(LPCTSTR lpszTemplateImage);
		// ͼλ;
		void WorldMapPositioning(POINT ptMap);
		// Ƿȴ;nAttackNPCType 0= 1=ְҵս
		bool IsWattingAttack(int nAttackNPCType);
		// ϷԻѡ;
		bool ClickDlgSetup(LPCSTR lpszTemplateImage);
		// ϷԻĶѡ;
		bool ClickDlgSetup(std::vector<std::string> vtOptions);

		// NPCͨͼѰ·;
		bool FindNPCByWorldMap(LPCTSTR lpszNPCName);
		// NPCȶλλãͨͼ;
		bool FindNPCByIcon(POINT ptMap, LPCTSTR lpszNPCName);
		// NPCλָλúλõNPC;
		bool FindNPCByIconAndPos(LPCTSTR lpszNPCName, POINT ptMap, POINT ptNpc);
		// NPCmapеNPC;
		bool FindNPCByMap(LPCTSTR lpszNPCName);
		// ǷSPȫֵ
		bool IsSPBelowSafeValue(BOOL IsRole, BOOL IsIdle, int nSafeValue = 30);
		// ǷHPȫֵ
		bool IsHPBelowSafeValue(BOOL IsRole, BOOL IsIdle, int nSafeValue = 30);

	public:
		// 뾵ս;
		// bHasSummonerǷٻ;
		// nZJType:ػ;
		// bAggressiveSkill:ڵϻԼ; true:, false:Լ
		void FightingJY(BOOL bHasSummoner, int nZJType, BOOL bAggressiveSkill);
		// ְҵҽʦս;
		void FightingYS(LPCTSTR lpszSkillName);
		// ְҵҽʦս;
		void FightingOthers(LPCTSTR lpszName, LPCTSTR lpszSkillName);

		// ;
		void OpenChest(int nTimes=10);
		// ;
		void GetSaturdayPresents();
		void ExerciseSkill(INT nVK_Skill, BOOL bCheckAttack = FALSE);
	private:
		HANDLE m_hBattleJY;
		HANDLE m_hBattleJYEvent;
		HANDLE m_hBattleZYTZ;
	public:
		bool m_bHasSummoner;		// Ƿٻ;
		int m_nSummonerSkillType;	// ػ;
		bool m_bTargetOfRoleSkill;	// ＼ötrue = ˡ false = Լ;
		int m_nSkillShortcutKey;	// ܿݼ;

		void StartBattleJY();
		void StopBattleJY();
		static DWORD WINAPI BattleJYThread(LPVOID lpParam);

		void StartSkill();
		void StopSkill();
		static DWORD WINAPI SkillThread(LPVOID lpParam);

		void StartRepeat();
		void StopRepeat();
		static DWORD WINAPI RepeatThread(LPVOID lpParam);
	};

};