#include "stdafx.h"
#include "CVideoCapture.h"

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <process.h>
#include <d3d11.h>
#include <dxgi1_2.h>

#pragma comment(lib, "d3d11")
#pragma comment(lib, "dxgi")

#ifndef _VIDEO_SOURCE_
#define _VIDEO_SOURCE_
typedef struct tDXGIVideoSource
{
	int		m_nLeft;//ֵ-
	int		m_nTop;//ֵ-
	int		m_nWidth;//-
	int		m_nHeight;//-߶

	bool					m_bCaptureCursor;//Ƿץȡ
	bool					m_bActive;//Ƿ񼤻ǷȡƵ֡
	HANDLE					m_hCaptureThread;//߳̾
	HANDLE					m_hStopSignal;//ֹ߳ͣź

	CRITICAL_SECTION		m_csMemLock;//ݷʻ
	void* m_memRawBuffer;//RGBݴŻ
	int						m_nMemSize;//RGBݻС

	ID3D11Device* m_hDevice;//豸
	ID3D11DeviceContext* m_hContext;//豸
	IDXGIOutputDuplication* m_hDeskDupl;//
	DXGI_OUTPUT_DESC        m_dxgiOutDesc;//-ֱʵϢ

	LPVideoDataRealCallback m_pVideoDataRealCalBack;//ʵʱݻص
	void* m_pVideoDataRealCalBackUser;//ʵʱûܶ
}DXGIVideoSource, * LPDXGIVideoSource;
#endif

//һƵԴ
void DXGIAllocVideoResource(LPDXGIVideoSource* pSource);
//ͷƵԴ
void DXGIReleaseVideoResource(LPDXGIVideoSource pSource);
//ʼƵ
bool DXGIStartVideoCapture(LPDXGIVideoSource pSource);
//ֹͣƵ
void DXGIStopVideoCapture(LPDXGIVideoSource pSource);
//Ƶѭ߳
DWORD WINAPI DXGIOnVideoCaptureThread(LPVOID param);
//Ƶݲ
bool DXGIDoVideoCapture(LPDXGIVideoSource pSource);
//Ƶݲ
bool DXGIProcessVideoCaptureData(LPDXGIVideoSource pSource);

const IID IID_IDXGIDevice = { 0x54ec77fa, 0x1377, 0x44e6, { 0x8c, 0x32, 0x88, 0xfd, 0x5f, 0x44, 0xc8, 0x4c } };
const IID IID_IDXGIAdapter = { 0x2411e7e1, 0x12ac, 0x4ccf, { 0xbd, 0x14, 0x97, 0x98, 0xe8, 0x53, 0x4d, 0xc0 } };
const IID IID_IDXGIOutput1 = { 0x00cddea8, 0x939b, 0x4b83, { 0xa3, 0x40, 0xa6, 0x85, 0x22, 0x66, 0x66, 0xcc } };
const IID IID_ID3D11Texture2D = { 0x6f15aaf2, 0xd208, 0x4e89, { 0x9a, 0xb4, 0x48, 0x95, 0x35, 0xd3, 0x4f, 0x9c } };
const IID IID_IDXGISurface = { 0xcafcb56c, 0x6ac3, 0x4889, { 0xbf, 0x47, 0x9e, 0x23, 0xbb, 0xd2, 0x60, 0xec } };
//#define RESET_OBJECT(A) {if (A) A->lpVtbl->Release(A); A = NULL;}
#define RESET_OBJECT(A) {if (A) A->Release(); A = NULL;}

//һƵԴ
void DXGIAllocVideoResource(LPDXGIVideoSource* ppSource)
{
	//ʼ
	*ppSource = (LPDXGIVideoSource)malloc(sizeof(DXGIVideoSource));
	((LPDXGIVideoSource)*ppSource)->m_bActive = false;
	((LPDXGIVideoSource)*ppSource)->m_bCaptureCursor = false;
	((LPDXGIVideoSource)*ppSource)->m_hCaptureThread = NULL;
	((LPDXGIVideoSource)*ppSource)->m_hStopSignal = CreateEvent(NULL, TRUE, FALSE, NULL);
	((LPDXGIVideoSource)*ppSource)->m_memRawBuffer = NULL;
	((LPDXGIVideoSource)*ppSource)->m_pVideoDataRealCalBack = NULL;
	((LPDXGIVideoSource)*ppSource)->m_pVideoDataRealCalBackUser = NULL;
	InitializeCriticalSection(&((LPDXGIVideoSource)*ppSource)->m_csMemLock);

	HRESULT hr = S_OK;
	//Direct3D
	D3D_DRIVER_TYPE DriverTypes[] =
	{
		D3D_DRIVER_TYPE_HARDWARE, //Ӳ
		D3D_DRIVER_TYPE_WARP,//-ܸ
		D3D_DRIVER_TYPE_REFERENCE, //-ȸߣٶ
		D3D_DRIVER_TYPE_SOFTWARE,//-ܵ
	};

	UINT NumDriverTypes = ARRAYSIZE(DriverTypes);
	D3D_FEATURE_LEVEL FeatureLevels[] =
	{
		D3D_FEATURE_LEVEL_11_0,
		D3D_FEATURE_LEVEL_10_1,
		D3D_FEATURE_LEVEL_10_0,
		D3D_FEATURE_LEVEL_9_1
	};

	//ʼD3D豸-m_hDevice
	UINT NumFeatureLevels = ARRAYSIZE(FeatureLevels);
	D3D_FEATURE_LEVEL FeatureLevel;
	for (UINT DriverTypeIndex = 0; DriverTypeIndex < NumDriverTypes; ++DriverTypeIndex)
	{
		hr = D3D11CreateDevice(NULL, DriverTypes[DriverTypeIndex], NULL, 0, FeatureLevels, NumFeatureLevels, D3D11_SDK_VERSION, &((LPDXGIVideoSource)*ppSource)->m_hDevice, &FeatureLevel, &((LPDXGIVideoSource)*ppSource)->m_hContext);
		if (SUCCEEDED(hr))
		{
			break;
		}
	}

	if (FAILED(hr))
	{
		goto exit;
	}

	IDXGIDevice* hDxgiDevice = NULL;
	hr = ((LPDXGIVideoSource)*ppSource)->m_hDevice->QueryInterface(IID_IDXGIDevice/*__uuidof(IDXGIDevice)*/, (void**)(&hDxgiDevice));
	if (FAILED(hr))
	{
		goto exit;
	}

	//ȡ-m_dxgiOutDescҪǻȡֱʴС
	IDXGIAdapter* hDxgiAdapter = NULL;
	hr = hDxgiDevice->GetParent(IID_IDXGIAdapter, (void**)(&hDxgiAdapter));
	RESET_OBJECT(hDxgiDevice);
	if (FAILED(hr))
	{
		goto exit;
	}

	INT nOutput = 0;
	IDXGIOutput* hDxgiOutput = NULL;
	hr = hDxgiAdapter->EnumOutputs(nOutput, &hDxgiOutput);
	RESET_OBJECT(hDxgiAdapter);
	if (FAILED(hr))
	{
		goto exit;
	}

	hDxgiOutput->GetDesc(&((LPDXGIVideoSource)*ppSource)->m_dxgiOutDesc);

	IDXGIOutput1* hDxgiOutput1 = NULL;
	hr = hDxgiOutput->QueryInterface(IID_IDXGIOutput1, (void**)(&hDxgiOutput1));
	RESET_OBJECT(hDxgiOutput);
	if (FAILED(hr))
	{
		goto exit;
	}

	hr = hDxgiOutput1->DuplicateOutput((IUnknown*)((LPDXGIVideoSource)*ppSource)->m_hDevice, (IDXGIOutputDuplication**)&((LPDXGIVideoSource)*ppSource)->m_hDeskDupl);
	RESET_OBJECT(hDxgiOutput1);
	if (FAILED(hr))
	{
		goto exit;
	}

	return;
exit:
	DXGIReleaseVideoResource((LPDXGIVideoSource)*ppSource);
	*ppSource = NULL;
}

//ͷƵԴ
void DXGIReleaseVideoResource(LPDXGIVideoSource pSource)
{
	RESET_OBJECT(pSource->m_hDeskDupl);
	RESET_OBJECT(pSource->m_hContext);
	RESET_OBJECT(pSource->m_hDevice);
	free(((LPDXGIVideoSource)pSource)->m_memRawBuffer);
	((LPDXGIVideoSource)pSource)->m_memRawBuffer = NULL;
	DeleteCriticalSection(&((LPDXGIVideoSource)pSource)->m_csMemLock);
	free(pSource);
	pSource = NULL;
}

//ʼƵ
bool DXGIStartVideoCapture(LPDXGIVideoSource pSource)
{
	// ͷ֮ǰĵĴͼĻ
	free(((LPDXGIVideoSource)pSource)->m_memRawBuffer);
	((LPDXGIVideoSource)pSource)->m_memRawBuffer = NULL;
	((LPDXGIVideoSource)pSource)->m_nMemSize = 0;

	//ͼĻС
	((LPDXGIVideoSource)pSource)->m_nMemSize = pSource->m_nWidth * pSource->m_nHeight * 4;//ȡͼλͼ32λ*4
	((LPDXGIVideoSource)pSource)->m_memRawBuffer = (char*)malloc(((LPDXGIVideoSource)pSource)->m_nMemSize);
	memset(((LPDXGIVideoSource)pSource)->m_memRawBuffer, 0, ((LPDXGIVideoSource)pSource)->m_nMemSize);

	//ͼ߳
	unsigned int dwThreadId;
	pSource->m_hCaptureThread = (HANDLE)_beginthreadex(NULL,
		0,
		(_beginthreadex_proc_type)&DXGIOnVideoCaptureThread,
		pSource,
		THREAD_PRIORITY_NORMAL,
		&dwThreadId);
	if (!pSource->m_hCaptureThread)
		return false;

	return true;
}

//ֹͣƵ
void DXGIStopVideoCapture(LPDXGIVideoSource pSource)
{
	//ֹ߳ͣź
	SetEvent(pSource->m_hStopSignal);
	//ȴ̰߳ȫ˳
	if (pSource->m_bActive)
	{
		WaitForSingleObject(pSource->m_hCaptureThread, INFINITE);
	}

	pSource->m_nMemSize = 0;
}

//Ƶѭ߳
DWORD WINAPI DXGIOnVideoCaptureThread(LPVOID param)
{
	LPDXGIVideoSource pSource = (LPDXGIVideoSource)param;
	DXGIDoVideoCapture(pSource);
	_endthreadex(0);
	return 0;
}

//Ƶѭ߳-߳
bool DXGIDoVideoCapture(LPDXGIVideoSource pSource)
{
	DWORD        dwTimeout = 1;
	DWORD dwStartTickCount = GetTickCount();

	// ȴʱһͼݻȡ
	while (WaitForSingleObject(pSource->m_hStopSignal, dwTimeout) == WAIT_TIMEOUT)
	{
		if (DXGIProcessVideoCaptureData(pSource))
		{
			if (((LPDXGIVideoSource)pSource)->m_bActive)
			{
				//ȡͼɹصݸӦòû
				if (pSource->m_pVideoDataRealCalBack)
				{
					pSource->m_pVideoDataRealCalBack((LPBYTE)pSource->m_memRawBuffer, pSource->m_nMemSize, pSource->m_nWidth, pSource->m_nHeight, pSource->m_pVideoDataRealCalBackUser);
				}
			}
			else
			{
				// Ϊһ֡ǺҪԣԭ򣿣
				((LPDXGIVideoSource)pSource)->m_bActive = true;
			}
		}
	}

	//رź
	CloseHandle(pSource->m_hStopSignal);
	pSource->m_hStopSignal = NULL;
	//ر߳̾
	CloseHandle(pSource->m_hCaptureThread);
	pSource->m_hCaptureThread = NULL;
	((LPDXGIVideoSource)pSource)->m_bActive = false;
	return true;
}

//
//ҵ
//
bool AttatchToThread(VOID)
{
	HDESK hOldDesktop = GetThreadDesktop(GetCurrentThreadId());
	HDESK hCurrentDesktop = OpenInputDesktop(0, FALSE, GENERIC_ALL);
	if (!hCurrentDesktop)
	{
		return false;
	}

	bool bDesktopAttached = SetThreadDesktop(hCurrentDesktop);
	CloseDesktop(hOldDesktop);
	CloseDesktop(hCurrentDesktop);
	hCurrentDesktop = NULL;

	return bDesktopAttached;
}

//Ƶݲ
bool DXGIProcessVideoCaptureData(LPDXGIVideoSource pSource)
{
	//ҵ
	if (!AttatchToThread())
	{
		return false;
	}

	///ȡĻ
	IDXGIResource* hDesktopResource = NULL;
	DXGI_OUTDUPL_FRAME_INFO FrameInfo;
	HRESULT hr = pSource->m_hDeskDupl->AcquireNextFrame(500, &FrameInfo, &hDesktopResource);
	if (FAILED(hr))
	{
		//
		// һЩwin10ϵͳ,ûб仯£
		// ᷢʱ󣬵ⲢǷ˴󣬶ϵͳŻˢ¶µġ
		// ԣûҪFALSEزκݵTRUE
		//
		return true;
	}

	//ȡ2D
	ID3D11Texture2D* hAcquiredDesktopImage = NULL;
	hr = hDesktopResource->QueryInterface(IID_ID3D11Texture2D, (void**)(&hAcquiredDesktopImage));
	RESET_OBJECT(hDesktopResource);
	if (FAILED(hr))
	{
		return false;
	}

	D3D11_TEXTURE2D_DESC frameDescriptor;
	hAcquiredDesktopImage->GetDesc(&frameDescriptor);

	//һµ2D,ڰ hAcquiredDesktopImagecopyȥ
	ID3D11Texture2D* hNewDesktopImage = NULL;
	frameDescriptor.Usage = D3D11_USAGE_STAGING;
	frameDescriptor.CPUAccessFlags = D3D11_CPU_ACCESS_READ;
	frameDescriptor.BindFlags = 0;
	frameDescriptor.MiscFlags = 0;
	frameDescriptor.MipLevels = 1;
	frameDescriptor.ArraySize = 1;
	frameDescriptor.SampleDesc.Count = 1;
	hr = pSource->m_hDevice->CreateTexture2D( &frameDescriptor, NULL, &hNewDesktopImage);
	if (FAILED(hr))
	{
		RESET_OBJECT(hAcquiredDesktopImage);
		pSource->m_hDeskDupl->ReleaseFrame();
		return false;
	}

	///ȡ֡ 
	pSource->m_hContext->CopyResource((ID3D11Resource*)hNewDesktopImage, (ID3D11Resource*)hAcquiredDesktopImage);
	RESET_OBJECT(hAcquiredDesktopImage);
	pSource->m_hDeskDupl->ReleaseFrame();

	// ȡ2Dı
	IDXGISurface* hStagingSurf = NULL;
	hr = hNewDesktopImage->QueryInterface(IID_IDXGISurface, (void**)(&hStagingSurf));
	RESET_OBJECT(hNewDesktopImage);
	if (FAILED(hr))
	{
		return false;
	}

	//ӳ,Ӷȡݵַ
	//ʱ mappedRect.pBits ָڴԭʼͼ, ΪDXGI̶Ϊ 32λɫ
	//mappedRect.pBits ָľ BGRA Ԫ
	DXGI_MAPPED_RECT mappedRect;
	hr = hStagingSurf->Map( &mappedRect, DXGI_MAP_READ);
	if (SUCCEEDED(hr))
	{
		WORD bitsPerPixel = 4;	// ÿصռ4ֽ - RGBA
		int iWidth = pSource->m_dxgiOutDesc.DesktopCoordinates.right - pSource->m_dxgiOutDesc.DesktopCoordinates.left;
		int iHeight = pSource->m_dxgiOutDesc.DesktopCoordinates.bottom - pSource->m_dxgiOutDesc.DesktopCoordinates.top;
		int iCopyDataLength = (pSource->m_nWidth * 32 + 31) / 32 * bitsPerPixel;
		int j = 0;
		for (int h = pSource->m_nTop; h < pSource->m_nTop + pSource->m_nHeight; h++)
		{
			int iSrcOffset = (h * iWidth + pSource->m_nLeft) * bitsPerPixel;
			BYTE* pSrc = mappedRect.pBits + iSrcOffset;
			int iDesOffset = (pSource->m_nWidth * 32 + 31) / 32 * j * bitsPerPixel;
			BYTE* pDes = (BYTE*)pSource->m_memRawBuffer + iDesOffset;
			memcpy(pDes, pSrc, iCopyDataLength);
			j++;
		}

		hStagingSurf->Unmap();
	}

	RESET_OBJECT(hStagingSurf);
	return SUCCEEDED(hr);
}

//ͼݻص
void DXGISetVideoCaptureDataRealCallback(LPDXGIVideoSource pSource, LPVideoDataRealCallback pVideoDataRealCalBack, void* pUser)
{
	pSource->m_pVideoDataRealCalBack = pVideoDataRealCalBack;
	pSource->m_pVideoDataRealCalBackUser = pUser;
}


// DXGIʽƵصʼƵ
void* DXGI_VideoSourceStartCapture(int left, int top, int width, int height, LPVideoDataRealCallback pCallback, void* pUser)
{
	// һƵԴ
	LPDXGIVideoSource pSource = NULL;
	DXGIAllocVideoResource(&pSource);

	//沶
	printf("¼left=%d,top=%d,w=%d,h=%d\n", left, top, width, height);
	pSource->m_nLeft = left;
	pSource->m_nTop = top;
	pSource->m_nWidth = width;
	pSource->m_nHeight = height;

	//ͼݻص
	DXGISetVideoCaptureDataRealCallback(pSource, pCallback, pUser);
	if (pSource && DXGIStartVideoCapture(pSource))
	{
		return pSource;
	}
	else
	{
		goto exit;
	}

exit:
	//ͷţͷԴ
	DXGIReleaseVideoResource(pSource);
	pSource = NULL;
	return pSource;
}

// ֹͣƵݲ
bool DXGI_VideoSourceStopCapture(void* pSource)
{
	if (pSource == NULL)
		return true;

	DXGISetVideoCaptureDataRealCallback((LPDXGIVideoSource)pSource, NULL, NULL);
	DXGIStopVideoCapture((LPDXGIVideoSource)pSource);
	return true;
}